unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);

    function CharAsciiToInt(a : char) : integer ; // AXL[R[hŐl
    procedure putword(locateX,locateY: Integer ; caption : string; Write : TImage);   // 
    procedure putwordbit(a,b,c: Integer ; Write : TImage);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    { Private 錾 }

  public
    { Public 錾 }
  end;

var
  Form1: TForm1;
  Load_bmap: Tbitmap;           // [h摜
  Rect_D,Rect_L,Rect_M: TRect;	// ėpEɃOtBbN`掞

  // ŗLe[u
  WordTable : array[0..95] of Integer =
  (37,37,37,37,37,38,37,37,37,37,37,37,37,39,37,37,
    0, 1, 2, 3, 4, 5, 6, 7, 8, 9,37,37,37,37,37,37,
   37,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,
   26,27,28,29,30,31,32,33,34,35,36,37,37,37,37,37,
   37,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,
   26,27,28,29,30,31,32,33,34,35,36,37,37,37,37,37
  );

implementation

{$R *.dfm}

function TForm1.CharAsciiToInt(a : char) : integer ; // AXL[R[hŐl
type
  // p̗̂p(_ZJ)
  uni1 = record
    case flg:Integer of
      0:(aa : byte);
      1:(bb : char);
    end;
var
  vuni : uni1;
begin
  vuni.flg := 0;
  vuni.bb := a;
  vuni.flg := 1;
  Result := vuni.aa;
end;

procedure TForm1.putword(locateX,locateY: Integer ; caption : String ; Write : TImage);{Timage}

var
  loop1,len : Integer;
  wordasci1,wordasci2 : Integer;


begin
  len := Length(caption); // ̒擾
  for loop1:=1 to len do                               //}bv𔒎
    begin
    //  p
    //wordasci1 := CharAsciiToInt(caption[loop1]);
    //  Ord
    wordasci1 := Ord(caption[loop1]);
    if ((wordasci1>31) and (wordasci1<128)) then
     wordasci2 := WordTable[wordasci1-32]
    else
     wordasci2 := 37;
    putwordbit( locateX+(loop1-1)*8 , locateY , wordasci2 , Write);
    end;
end;

procedure TForm1.putwordbit(a,b,c: Integer ; Write : TImage); //ʉ߉摜
var
  Rect_L,Rect_M: TRect;		//rbg}bv݂Load_Bmap̂
  Px,Py : Integer;              //16*16̕cϐL[ɂāA
begin                           //ɂPUŊ]
  //Px := (c mod 16)*8;           //cɂPUŊ𓖂ďł
  //Py := (c div 16)*8;
  Px := (c mod 48)*8;           //cɂPUŊ𓖂ďł
  Py := 0;
  Rect_L := Rect(Px,Py,Px+8,Py+8);
  Rect_M := Rect(a,b,a+8,b+8);
  Write.Canvas.CopyMode := cmSrcCopy;                    // ڃx^ŏ
  Write.Canvas.CopyRect(Rect_M,Load_Bmap.Canvas,Rect_L); //
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  //p^[f[^[[h
  Load_Bmap := TBitmap.Create;
  Load_Bmap.Width := 320;
  Load_Bmap.Height := 128;
  Rect_L := Rect(0, 0, 320, 128);
  Load_Bmap.Canvas.CopyMode := cmSrcCopy;
  //Load_Bmap.Canvas.CopyRect(Rect_L, Image1.Canvas, Rect_L);
  Load_Bmap.LoadFromFile(GetcurrentDir + '\bmp\font3.bmp');

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Image1.Canvas.Pen.Color := clWhite;
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.Rectangle(0,0,640,480);
  putword(0,0,Edit1.Text,Image1);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Load_Bmap.Free;
end;

end.
